-- SPDX-License-Identifier: CC0-1.0
let Genode = env:DHALL_GENODE

let Args =
        { config : Genode.Init.Type
        , rom : Genode.Prelude.Map.Type Text Genode.Boot.Rom
        }
      : Type

in    λ(args : Args)
    → { config =
          Genode.Init::{
          , verbose = True
          , defaultRoutes =
                Genode.Init.default.defaultRoutes
              # [ Genode.ServiceRoute.child "Timer" "timer" ]
          , children =
              [ { mapKey = "timer"
                , mapValue =
                    Genode.Init.Start::{
                    , binary = "linux_timer_drv"
                    , resources = { caps = 96, ram = Genode.units.MiB 1 }
                    , provides = [ "Timer" ]
                    }
                }
              , { mapKey = "init", mapValue = Genode.Init.toStart args.config }
              ]
          }
      , rom =
          let baseLinux = env:BASE_LINUX_MANIFEST
          
          let os = env:OS_MANIFEST
          
          in      Genode.Boot.toRomPaths
                    [ { mapKey = "ld.lib.so"
                      , mapValue = baseLinux.bin.ld-linux.mapValue
                      }
                    , baseLinux.bin.linux_timer_drv
                    , os.bin.init
                    , baseLinux.bin.core-linux
                    ]
                # args.rom
              : Genode.Prelude.Map.Type Text Genode.Boot.Rom
      }
