-- SPDX-License-Identifier: CC0-1.0

let Genode = env:DHALL_GENODE

in    λ ( _
        : {}
        )
    → Genode.Init::{
      , verbose = True
      , children =
          toMap
            { test-libc =
                  Genode.Init.Start::{
                  , binary = "test-libc"
                  , exitPropagate = True
                  , resources = { caps = 200, ram = Genode.units.MiB 400 }
                  , routes = [ Genode.ServiceRoute.parent "Timer" ]
                  , config =
                      Some
                        ( Genode.Prelude.XML.text
                            ''
                            <config>
                              <vfs>
                                <dir name="dev">
                                  <log/>
                                  <inline name="rtc">2019-08-20 15:01</inline>
                                </dir>
                              </vfs>
                              <libc stdout="/dev/log" stderr="/dev/log" rtc="/dev/rtc"/>
                            </config>
                            ''
                        )
                  }
                : Genode.Init.Start.Type
            }
      }
